Player = Class{__includes=Object,

	init = function(self)
		Object.init(self)
		self.img = love.graphics.newImage("assets/characters/Player.png")
		self.speed = 2.5
		self.collider = nil
		self.body = HC.rectangle(0,0,16,16)
	end,

	update = function(self,dt)
		self:updateInput(dt)
		self:updateWarpCollision()
	end,

	updateInput = function(self,dt)
		local handler = self.collider
		if handler == nil then return end
		if love.keyboard.isDown("down") then
			local y = handler:bottomResolve(self.x,self.y+self.speed,16,16)
			self.y = y
		end
		if love.keyboard.isDown("left") then
			local x = handler:leftResolve(self.x-self.speed,self.y,16,16)
			self.x = x
		end
		if love.keyboard.isDown("right") then
			local x = handler:rightResolve(self.x+self.speed,self.y,16,16)
			self.x = x
		end
		if love.keyboard.isDown("up") then
			local y = handler:topResolve(self.x,self.y-self.speed,16,16)
			self.y = y
		end
		self.body:moveTo(self.x+8,self.y+8)
	end,

	moveTo = function(self,x,y)
		self.x = x*16
		self.y = y*16
		self.body:moveTo(self.x+8,self.y+8)
	end,

	updateWarpCollision = function(self)
		if self.currentMap ~= nil and self.currentMap.warps ~= nil then
			for i,v in ipairs(self.currentMap.warps) do
				local col = self.body:collidesWith(v.body)
				if col == true then
					Temp.currentMap = v.map
					Temp.currentMapNewX = tonumber(v.mapX)
					Temp.currentMapNewY = tonumber(v.mapY)
					break
				end
			end
		end
	end,

	draw = function (self)
		love.graphics.setColor(255, 0, 255, 255)
		self.body:draw()
		Object.draw(self)
	end,

}