sceneMap = {}

sceneMap.tilemap = ""
sceneMap.player = nil
sceneMap.events = {}
sceneMap.warps = {}

function sceneMap:enter()
	print("Entering Scene Map")
	if Temp.hasStarted == false then
		local windowWidth  = love.graphics.getWidth()
    	local windowHeight = love.graphics.getHeight()
		self.tilemap = sti.new("data/maps/" .. Temp.initialMap .. ".lua")
		Temp.currentMap = Temp.initialMap
		Temp.lasttMap = Temp.initialMap
		self:setCollisionHandler()
		self:setWarps()
		GamePlayer = Player()
		GamePlayer.collider = self.collisionHandler
		GamePlayer.currentMap = self
		GamePlayer:moveTo(Temp.initialX,Temp.initialY)
		Temp.hasStarted = true
	end
end

function sceneMap:update(dt)
	if not self:isTransition() then
		self.tilemap:update(dt)
		GamePlayer:update(dt)
	else
		self.tilemap = sti.new("data/maps/" .. Temp.currentMap .. ".lua")
		Temp.lasttMap = Temp.currentMap
		self:setCollisionHandler()
		self:removeWarps()
		self:setWarps()
		--GamePlayer = Player()
		GamePlayer.collider = self.collisionHandler
		GamePlayer.currentMap = self
		GamePlayer:moveTo(Temp.currentMapNewX,Temp.currentMapNewY)
	end
end

function sceneMap:isTransition()
	if Temp.currentMap ~= Temp.lasttMap then
		return true
	else
		return false
	end
end

function sceneMap:draw()
	self.tilemap:draw()
	graphics.draw()
	if _DebugMode then
		if self.warps ~= nil then
			for i,v in ipairs(self.warps) do
				love.graphics.setColor(255, 0, 0, 255)
				v.body:draw()
			end
		end
	end
end

function sceneMap:setCollisionHandler()
	if self.collisionHandler ~= nil then self.collisionHandler = nil end

	local heightmaps = {}

	local function getTile(x,y)
		if x < 1 then x = 1 end
		if y < 1 then y = 1 end
		if x > self.tilemap.width then x = self.tilemap.width end
		if y > self.tilemap.height then x = self.tilemap.height end
		return (self.tilemap:getTileData("layer1",x,y).gid)
	end

	local function getCollision(side,tile,x,y)
		--print(side,tile,x,y)
		if tile == 1 then return true
		
		else return false
		end
	end

	self.collisionHandler = tilecollider(getTile,16,16,getCollision,heightmaps,false)

end

function sceneMap:setWarps()

	if self.tilemap.layers["warps"] == nil then return end
	for k,v in ipairs(self.tilemap.layers["warps"].objects) do
		if v.shape == "rectangle" then
			--print(v.rectangle[2].y)
			local warp = {}
			local body = HC.polygon(v.rectangle[1].x,v.rectangle[1].y,
				v.rectangle[2].x,v.rectangle[2].y,
				v.rectangle[3].x,v.rectangle[3].y,
				v.rectangle[4].x,v.rectangle[4].y)
			warp.body = body
			warp.map = (v.properties.map)
			warp.mapX = (v.properties.mapX)
			warp.mapY = (v.properties.mapY)
			table.insert(self.warps,warp)
		end
	end

end

function sceneMap:removeWarps()
	for i,v in ipairs(self.warps) do
		HC.remove(v.body)
	end
	self.warps = {}
end